/*
 * VOfundecl.h
 * VO routine declarations
 *
 */

#ifndef VOFUNDECL_H
#define VOFUNDECL_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "std.h"
#include "dvrule.h"
#include "dvstd.h"
#include "dvtools.h"
#include "dvGR.h"
#include "VOstd.h"

/***
*** 
***/




/* VO/VOGraphics.c */
void VOgGenericDraw V_P_((VOGDRAWFUNPTR drawfunction,  ADDRESS drawargs,
	 RECTANGLE *objvp,  RECTANGLE *invp,  RECTANGLE **outvps));
void VOgLine V_P_((register DV_POINT *p1,  register DV_POINT *p2,  int pattern,
	 int width,  RECTANGLE *invp,  RECTANGLE **outvps));
void VOgMultiline V_P_((DV_POINT *pts,  int numpts,  int pattern,  int width,
	 RECTANGLE *invp,  RECTANGLE **outvps));
void VOgFrame V_P_((DV_POINT *p1,  DV_POINT *p2,  int pattern,  int width,
	 RECTANGLE *invp,  RECTANGLE **outvps));
void VOgRect V_P_((DV_POINT *p1,  DV_POINT *p2,  RECTANGLE *invp,
	 RECTANGLE **outvps));
void VOgReErase V_P_((DV_POINT *p1,  DV_POINT *p2,  RECTANGLE *invp,
	 RECTANGLE **outvps));
int VOgChSize V_P_((int newsize));
void VOgTextsize V_P_((char *string,  int text_direction,  int *width,
	 int *height));
void VOgText V_P_((char *string,  register DV_POINT *p,  int direction,
	 int position,  RECTANGLE *invp,  RECTANGLE **outvps));
void VOgvTextsize V_P_((char *string,  register DV_POINT *p,  int direction,
	 int position,  RECTANGLE *m));
void VOgvText V_P_((char *string,  register DV_POINT *p,  int direction,
	 int position,  RECTANGLE *invp,  RECTANGLE **outvps));
void VOgsText V_P_((char *string, register DV_POINT *p, RECTANGLE *invp, 
                   RECTANGLE **outvps));
void VOgsTextsize V_P_((char *string, DV_POINT *pt, RECTANGLE *textbox));
         

void VOgDot V_P_((DV_POINT *p,  RECTANGLE *invp,  RECTANGLE **outvps));
void VOgCircle V_P_((DV_POINT *center,  int radius,  int filled,
	 RECTANGLE *invp,  RECTANGLE **outvps));
void VOgArc V_P_((DV_POINT *center,  int radius,  int start,  int delta,
	 int filled,  RECTANGLE *invp,  RECTANGLE **outvps));
void VOgPolygon V_P_((DV_POINT *pts,  int numpts,  RECTANGLE *invp,
	 RECTANGLE **outvps));
void VOgCubic V_P_((DV_POINT *pts,  int pattern,  int width,  RECTANGLE *invp,
	 RECTANGLE **outvps));
BOOLPARAM VOgIsVisible V_P_((RECTANGLE *objvp,  RECTANGLE *invp,
	 RECTANGLE **outvps,  DV_BOOL *all_in,  DV_BOOL *covered));
void VOgRaster V_P_((ADDRESS raster,  DV_POINT *ll,  RECTANGLE *invp,
	 RECTANGLE **outvps));
void VOgVpPtsGet V_P_((DV_POINT *pts,  int numpts,  RECTANGLE *vp));
void VOgVpSort V_P_((register RECTANGLE *vp));

/***
*** 
***/




/* VO/VOarc.c */
OBJECT VOarCreate V_P_((OBJECT start,  OBJECT center,  OBJECT end,
	 ATTRIBUTES *attributes));
LONG VOarStatistic V_P_((int Flag));
OBJECT VOarReference V_P_((OBJECT arc));
void VOarDereference V_P_((OBJECT arc));
int VOarRefCount V_P_((OBJECT arc));
OBJECT VOarClone V_P_((OBJECT arc));
BOOLPARAM VOarValid V_P_((OBJECT arc));
void VOarSave V_P_((OBJECT arc, OBJECT stream));
OBJECT VOarRetrieve V_P_((OBJECT stream));
BOOLPARAM VOarTraverse V_P_((OBJECT arc,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOarAtGet V_P_((OBJECT arc,  register ATTRIBUTES *attributes));
void VOarAtSet V_P_((OBJECT arc,  register ATTRIBUTES *attributes));
OBJECT VOarPtGet V_P_((OBJECT arc, int index));
void VOarPtSet V_P_((OBJECT arc,  int index,  OBJECT NewControlPoint));
void VOarBox V_P_((OBJECT arc,  register RECTANGLE *wvp,
	 RECTANGLE *svp));
void VOarXfBox V_P_((OBJECT arc,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOarXformBox V_P_((OBJECT arc,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOarIntersect V_P_((OBJECT arc,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOarEval V_P_((OBJECT arc,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
OBJECT VOarGetSlotTable V_P_((OBJECT arc));
void VOarSetSlotTable V_P_((OBJECT arc, OBJECT slots));
ADDRESS VOarDspEnv V_P_((OBJECT arc, ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOcircle.c */
OBJECT VOciCreate V_P_((OBJECT center,  OBJECT radiuspt,
	 ATTRIBUTES *attributes));
LONG VOciStatistic V_P_((int Flag));
OBJECT VOciReference V_P_((OBJECT circle));
void VOciDereference V_P_((OBJECT circle));
int VOciRefCount V_P_((OBJECT circle));
OBJECT VOciClone V_P_((OBJECT circle));
BOOLPARAM VOciValid V_P_((OBJECT circle));
void VOciSave V_P_((OBJECT circle, OBJECT stream));
OBJECT VOciRetrieve V_P_((OBJECT stream));
BOOLPARAM VOciTraverse V_P_((OBJECT circle,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOciAtGet V_P_((OBJECT circle,
	 register ATTRIBUTES *attributes));
void VOciAtSet V_P_((OBJECT circle,
	 register ATTRIBUTES *attributes));
OBJECT VOciPtGet V_P_((OBJECT circle, int index));
void VOciPtSet V_P_((OBJECT circle,  int index,
	 OBJECT NewControlPoint));
void VOciBox V_P_((OBJECT circle,  register RECTANGLE *wvp,
	 RECTANGLE *svp));
void VOciXfBox V_P_((OBJECT circle,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOciXformBox V_P_((OBJECT circle,  OBJECT xform, RECTANGLE *svp));
BOOLPARAM VOciIntersect V_P_((OBJECT circle,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOciEval V_P_((OBJECT circle,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
OBJECT VOciGetSlotTable V_P_((OBJECT circle));
void VOciSetSlotTable V_P_((OBJECT circle, OBJECT slots));
ADDRESS VOciDspEnv V_P_((OBJECT circle, ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOcolor.c */
OBJECT VOcoCreate V_P_((int format, ...));
OBJECT VOcoReference V_P_((OBJECT clr));
void VOcoDereference V_P_((OBJECT clr));
int VOcoRefCount V_P_((OBJECT clr));
OBJECT VOcoClone V_P_((OBJECT clr));
BOOLPARAM VOcoValid V_P_((OBJECT clr));
void VOcoSave V_P_((OBJECT clr, OBJECT stream));
OBJECT VOcoRetrieve V_P_((OBJECT stream));
BOOLPARAM VOcoConvertOnLoad V_P_((int flag));
OBJECT VOcoRgbGet V_P_((OBJECT clr));
OBJECT VOcoNdxGet V_P_((OBJECT clr));
void VOcoCsGet V_P_((OBJECT clr, COLOR_SPEC *clr_spec));
LONG VOcoIndex V_P_((OBJECT clr));
OBJECT VOcoForeSet V_P_((OBJECT clr));
OBJECT VOcoBackSet V_P_((OBJECT clr));
int VOcoSubtype V_P_((OBJECT clr));
BOOLPARAM VOcoRefSwitch V_P_((OBJECT clr, OBJECT newclr));

/***
*** 
***/





/* debug/VODBG.c */
void VOdbgCounts V_P_((void));
int VOdbgObPts V_P_((OBJECT obj));
int VOdbgDqList V_P_((OBJECT deque));
void VOdbgAttr V_P_((ATTRIBUTES *attr));
BOOLPARAM VOdbgOb V_P_((OBJECT obj)); 

/***
*** 
***/




/* VO/VOdg.c */
OBJECT VOdgCreate V_P_((ADDRESS dgp,  OBJECT ll,  OBJECT ur, ATTRIBUTES *attributes));
LONG VOdgStatistic V_P_((int Flag));
OBJECT VOdgReference V_P_((OBJECT datagroup));
void VOdgDereference V_P_((OBJECT datagroup));
int VOdgRefCount V_P_((OBJECT datagroup));
OBJECT VOdgClone V_P_((OBJECT datagroup));
BOOLPARAM VOdgValid V_P_((OBJECT datagroup));
void VOdgSave V_P_((OBJECT datagroup, OBJECT stream));
OBJECT VOdgRetrieve V_P_((OBJECT stream));
ADDRESS VOdgGetDgp V_P_((OBJECT datagroup));
ADDRESS VOdgAddress V_P_((OBJECT datagroup));
BOOLPARAM VOdgSetInfo V_P_((OBJECT datagroup, ...));
BOOLPARAM VOdgGetInfo V_P_((OBJECT datagroup, ...));
void VOdgVdAdd V_P_((OBJECT datagroup, VARDESC vdp));
void VOdgVdInsert V_P_((OBJECT datagroup, int indx, VARDESC vdp));
VARDESC VOdgVdRemove V_P_((OBJECT datagroup, int indx));
VARDESC VOdgVdSwitch V_P_((OBJECT datagroup, int indx, VARDESC vdp));
VARDESC VOdgVd V_P_((OBJECT datagroup, int indx));
BOOLPARAM VOdgTraverse V_P_((OBJECT datagroup,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOdgAtGet V_P_((OBJECT datagroup,
	 register ATTRIBUTES *attributes));
void VOdgAtSet V_P_((OBJECT datagroup,
	 register ATTRIBUTES *attributes));
OBJECT VOdgPtGet V_P_((OBJECT datagroup, int index));
void VOdgPtSet V_P_((OBJECT datagroup,  int index,
	 OBJECT NewControlPoint));
void VOdgBox V_P_((OBJECT datagroup,  RECTANGLE *wvp,  RECTANGLE *svp));
void VOdgXfBox V_P_((OBJECT dg,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOdgXformBox V_P_((OBJECT dg,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOdgIntersect V_P_((OBJECT datagroup,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOdgIsDrawable V_P_((OBJECT datagroup,  OBJECT xform));
BOOLPARAM VOdgIsDrawn V_P_((OBJECT datagroup));
BOOLPARAM VOdgEval V_P_((OBJECT datagroup,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
void VOdgErase V_P_((OBJECT datagroup, DRAW_ENV *de));
void VOdgUpdate V_P_((OBJECT datagroup));
void VOdgUpdateDraw V_P_((OBJECT datagroup,  RECTANGLE *vp,
	 RECTANGLE **obsvps));
void VOdgReset V_P_((OBJECT datagroup));
DRAW_INFO *VOdgGetDrawInfo V_P_((OBJECT datagroup));
OBJECT VOdgGetSlotTable V_P_((OBJECT datagroup));
void VOdgSetSlotTable V_P_((OBJECT datagroup,  OBJECT slots));
ADDRESS VOdgDspEnv V_P_((OBJECT datagroup,  ADDRESS *dspenvp));
void VOdgDraw V_P_((OBJECT datagroup, DRAW_ENV *de));
void VOdgRedraw V_P_((OBJECT datagroup, DRAW_ENV *de));
void VOdgSimpleRedraw V_P_((OBJECT datagroup,  DRAW_ENV *de));

/***
*** 
***/




/* VO/VOdeque.c */
OBJECT noop_addfun V_P_((OBJECT entity));
void noop_delfun V_P_((OBJECT entity));
OBJECT VOdqCreate V_P_((int initial_size));
OBJECT VOdqCreateGeneric V_P_((int initial_size,  VODQADDFUNPTR addfun,
	 VODQDELFUNPTR delfun,  VODQEQUALFUNPTR is_equalfun));
LONG VOdqStatistic V_P_((int Flag));
OBJECT VOdqReference V_P_((OBJECT deque));
void VOdqDereference V_P_((OBJECT deque));
int VOdqRefCount V_P_((OBJECT deque));
void VOdqDestroy V_P_((OBJECT deque));
OBJECT VOdqClone V_P_((OBJECT deque));
BOOLPARAM VOdqValid V_P_((OBJECT deque));
void VOdqSave V_P_((OBJECT deque, OBJECT stream));
OBJECT VOdqRetrieve V_P_((OBJECT stream));
LONG VOdqVersion V_P_((OBJECT deque));
BOOLPARAM VOdqTraverse V_P_((OBJECT deque,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOdqAddIndexed V_P_((OBJECT deque,  int index,  OBJECT object));
void VOdqAddDqIndexed V_P_((OBJECT deque,  int index,  OBJECT obdeque));
void VOdqAdd V_P_((OBJECT deque,  int position,  OBJECT object));
void VOdqAddDq V_P_((OBJECT deque,  int position,  OBJECT obdeque));
void VOdqReplaceEntry V_P_((OBJECT deque,  int position,
	 OBJECT object));
void VOdqSwapEntries V_P_((OBJECT deque,  int position1,
	 int position2));
void VOdqSort V_P_((OBJECT deque, VODQCOMPAREFUNPTR compare_fun ));
void VOdqDeleteIndexed V_P_((OBJECT deque, int position));
void VOdqDelete V_P_((OBJECT deque, OBJECT object));
void VOdqDeleteDq V_P_((OBJECT deque, OBJECT obdeque));
void VOdqDeleteAll V_P_((OBJECT deque));
int VOdqSize V_P_((OBJECT deque));
OBJECT VOdqTransferIndexed V_P_((OBJECT deque, int position));
OBJECT VOdqGetEntry V_P_((OBJECT deque, int index));
int VOdqHasEntry V_P_((OBJECT deque, OBJECT object));
BOOLPARAM VOdqEval V_P_((OBJECT deque,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de,  BOOLFUNPTR subtype_fcn));

/***
*** 
***/




/* VO/VOdrawing.c */
OBJECT VOdrCreate V_P_((void));
VI OBJECT VOdrCreateFromDeque V_P_((OBJECT deque));
LONG VOdrStatistic V_P_((int Flag));
OBJECT VOdrReference V_P_((OBJECT drawing));
void VOdrDereference V_P_((OBJECT drawing));
int VOdrRefCount V_P_((OBJECT drawing));
OBJECT VOdrClone V_P_((OBJECT drawing));
BOOLPARAM VOdrValid V_P_((OBJECT drawing));
void VOdrSave V_P_((OBJECT drawing, OBJECT stream));
OBJECT VOdrRetrieve V_P_((OBJECT stream));
BOOLPARAM VOdrTraverse V_P_((OBJECT drawing,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOdrXfBox V_P_((OBJECT drawing,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOdrXformBox V_P_((OBJECT drawing,  OBJECT xform,
				RECTANGLE *svp));
void VOdrBox V_P_((OBJECT drawing,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
BOOLPARAM VOdrIntersect V_P_((OBJECT drawing,  OBJECT xform,
	 RECTANGLE *vp));
BOOLPARAM VOdrObAdd V_P_((OBJECT drawing, OBJECT obj));
BOOLPARAM VOdrObAddNamed V_P_((OBJECT drawing,  OBJECT obj,
	 char *name));
BOOLPARAM VOdrObReplace V_P_((OBJECT drawing,  OBJECT currobj,
	 OBJECT newobj));
BOOLPARAM VOdrObDelete V_P_((OBJECT drawing, OBJECT obj));
void VOdrObBottom V_P_((OBJECT drawing, OBJECT object));
void VOdrObTop V_P_((OBJECT drawing, OBJECT object));
BOOLPARAM VOdrLoSet V_P_((OBJECT drawing, DV_POINT *wcpt));
BOOLPARAM VOdrEval V_P_((OBJECT drawing,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de,  BOOLFUNPTR subtype_fcn));
BOOLPARAM VOdrEvalObject V_P_((OBJECT drawing,  OBJECT object,
	 V_OB_EVAL_TYPE eval_type,  DRAW_ENV *de,  BOOLFUNPTR subtype_fcn,
	 BOOLPARAM skip_sd_check));
void VOdrObDraw V_P_((OBJECT drawing,  OBJECT obj,
	 VOIDFUNPTR draw_fcn));
void VOdrObErase V_P_((OBJECT drawing,  OBJECT obj,
	 VOIDFUNPTR erase_fcn));
void VOdrBackDraw V_P_((OBJECT drawing));
void VOdrBounds V_P_((OBJECT xform,  register RECTANGLE *bounds));
OBJECT VOdrForecolor V_P_((OBJECT drawing, OBJECT clr));
OBJECT VOdrBackcolor V_P_((OBJECT drawing, OBJECT clr));
OBJECT VOdrOffcolor V_P_((OBJECT clr));
void VOdrAddVp V_P_((OBJECT drawing,  OBJECT viewport,  OBJECT xform));
void VOdrDelVp V_P_((OBJECT drawing, OBJECT viewport));
OBJECT VOdrGetVp V_P_((OBJECT drawing, int view_index));
OBJECT VOdrGetObjectDeque V_P_((OBJECT drawing));
void VOdrAddName V_P_((OBJECT drawing,  OBJECT object,  char *name));
void VOdrDeleteName V_P_((OBJECT drawing, OBJECT object));
ADDRESS VOdrNameTraverse V_P_((OBJECT drawing,  VODRNAMETRVRSFUNPTR fun,
	 ADDRESS args));
char *VOdrGetName V_P_((OBJECT drawing, OBJECT object));
OBJECT VOdrGetNamedObject V_P_((OBJECT drawing,  char *name));
OBJECT VOdrGetSlotTable V_P_((OBJECT drawing));
void VOdrSetSlotTable V_P_((OBJECT drawing, OBJECT slots));
ADDRESS VOdrDspEnv V_P_((OBJECT drawing,  ADDRESS *dspenvp));
double VOdrGetScale V_P_((OBJECT drawing));
void VOdrSetScale V_P_((OBJECT drawing, double scale));
void VOdrPoolFree V_P_((void));

/***
*** 
***/




/* VO/VOdynamic.c */
OBJECT VOdyCreate V_P_((void));
LONG VOdyStatistic V_P_((int Flag));
BOOLPARAM VOdyAttachData V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj,  float *low_rangep,  float *high_rangep,  OBJECT ref_pt,
	 OBJECT polygon));
void VOdyDetachData V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj));
OBJECT VOdyGetDataObj V_P_((OBJECT dynamic,  int dyn_action,
	 int index));
BOOLPARAM VOdyGetVisibility V_P_((OBJECT dynamic));
BOOLPARAM VOdyChanged V_P_((OBJECT dynamic,  OBJECT object));
void VOdyUpdate V_P_((OBJECT dynamic, OBJECT object));
OBJECT VOdyAttachObject V_P_((OBJECT dynamic,  OBJECT object));
OBJECT VOdyAttachObjectWithState V_P_((OBJECT dynamic,  OBJECT object, INT asleep));
BOOLPARAM VOdyDetachObject V_P_((OBJECT dynamic,  OBJECT object));
BOOLPARAM VOdySetState V_P_((OBJECT dynamic,  OBJECT object,
	 int state));
void VOdyReset V_P_((OBJECT dynamic, OBJECT object));
BOOLPARAM VOdySetEraseMethod V_P_((OBJECT dynamic,
	 int erase_method));
int VOdyGetEraseMethod V_P_((OBJECT dynamic));
BOOLPARAM VOdySetEraseColor V_P_((OBJECT dynamic,  OBJECT color));
OBJECT VOdyGetEraseColor V_P_((OBJECT dynamic));
BOOLPARAM VOdySetRange V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj,  float *low_rangep,  float *high_rangep));
BOOLPARAM VOdyGetRange V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj,  float *low_rangep,  float *high_rangep));
BOOLPARAM VOdySetPath V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj,  OBJECT polygon_path));
OBJECT VOdyGetPath V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj));
BOOLPARAM VOdySetRefPoint V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj,  OBJECT ref_point));
OBJECT VOdyGetRefPoint V_P_((OBJECT dynamic,  int dyn_action,
	 OBJECT data_obj));
OBJECT VOdyClone V_P_((OBJECT dynamic));
BOOLPARAM VOdyTraverse V_P_((OBJECT dynamic,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOdySave V_P_((OBJECT dynamic, OBJECT stream));
OBJECT VOdyRetrieve V_P_((OBJECT stream));
OBJECT VOdyGetSlotTable V_P_((OBJECT dynamic));
void VOdySetSlotTable V_P_((OBJECT dynamic, OBJECT slots));
BOOLPARAM VOdyValid V_P_((OBJECT dynamic));
BOOLPARAM VOdyParentTraverse V_P_((OBJECT dynamic,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
int VOdyGetNumParents V_P_((OBJECT dynamic));
void VOdyReOrderActions V_P_((OBJECT dynamic));
BOOLPARAM VOdySetTextFormat V_P_((OBJECT dynamic,  int dyn_action,
	 char *format));
char *VOdyGetTextFormat V_P_((OBJECT dynamic,  int dyn_action));
int VOdyGetAction V_P_((OBJECT dynamic, int index));
BOOLPARAM VOdyEval V_P_((OBJECT dynamic,  OBJECT object,
	 V_OB_EVAL_TYPE eval_type,  DRAW_ENV *de,  BOOLFUNPTR subtype_fcn));
BOOLPARAM VOdyEvaluating V_P_((OBJECT dynamic,  OBJECT object));

/***
*** 
***/




/* VO/VOedge.c */
OBJECT VOedCreate V_P_((OBJECT Node1,  OBJECT Node2,  OBJECT Geometry,
	 ATTRIBUTES *attributes));
LONG VOedStatistic V_P_((int Flag));
OBJECT VOedReference V_P_((OBJECT edge));
void VOedDereference V_P_((OBJECT edge));
int VOedRefCount V_P_((OBJECT edge));
OBJECT VOedClone V_P_((OBJECT edge));
BOOLPARAM VOedValid V_P_((OBJECT edge));
void VOedSave V_P_((OBJECT edge, OBJECT stream));
OBJECT VOedRetrieve V_P_((OBJECT stream));
BOOLPARAM VOedTraverse V_P_((OBJECT edge,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
OBJECT VOedGetNode V_P_((OBJECT edge, int i));
OBJECT VOedSetNode V_P_((OBJECT edge,  int i,  OBJECT NewNode));
OBJECT VOedGetGeometry V_P_((OBJECT edge));
OBJECT VOedSetGeometry V_P_((OBJECT edge,  OBJECT NewGeometry));
LONG VOedGetVisit V_P_((OBJECT edge));
LONG VOedSetVisit V_P_((OBJECT edge, LONG NewCount));
void VOedClearVisit V_P_((void));
BOOLPARAM VOedGetMark V_P_((OBJECT edge));
BOOLPARAM VOedSetMark V_P_((OBJECT edge,  BOOLPARAM NewMark));
void VOedClearMark V_P_((void));
OBJECT VOedGetSlotTable V_P_((OBJECT edge));
void VOedSetSlotTable V_P_((OBJECT edge, OBJECT slots));
void VOedAtGet V_P_((OBJECT edge,  register ATTRIBUTES *attributes));
void VOedAtSet V_P_((OBJECT edge,  register ATTRIBUTES *attributes));
OBJECT VOedPtGet V_P_((OBJECT edge, int index));
void VOedPtSet V_P_((OBJECT edge,  int index,  OBJECT NewControlPoint));
void VOedBox V_P_((OBJECT edge,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
void VOedXfBox V_P_((OBJECT edge,  OBJECT xform,
	 register RECTANGLE *svp));
VI BOOLPARAM VOedXformBox V_P_((OBJECT edge,  OBJECT xform, RECTANGLE *svp));
BOOLPARAM VOedIntersect V_P_((OBJECT edge,  OBJECT xform,
	 RECTANGLE *vp));
BOOLPARAM VOedEval V_P_((OBJECT edge,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
ADDRESS VOedDspEnv V_P_((OBJECT edge, ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOellipse.c */
VI OBJECT VOelCreate V_P_((OBJECT pt1,  OBJECT pt2,  OBJECT pt3,
	 ATTRIBUTES *attributes));
VI LONG VOelStatistic V_P_((int Flag));
VI OBJECT VOelReference V_P_((OBJECT ellipse));
VI void VOelDereference V_P_((OBJECT ellipse));
VI int VOelRefCount V_P_((OBJECT ellipse));
VI OBJECT VOelClone V_P_((OBJECT ellipse));
VI BOOLPARAM VOelValid V_P_((OBJECT ellipse));
VI void VOelSave V_P_((OBJECT ellipse, OBJECT stream));
VI OBJECT VOelRetrieve V_P_((OBJECT stream));
VI BOOLPARAM VOelTraverse V_P_((OBJECT ellipse,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
VI void VOelAtGet V_P_((OBJECT ellipse,
	 register ATTRIBUTES *attributes));
VI void VOelAtSet V_P_((OBJECT ellipse,
	 register ATTRIBUTES *attributes));
VI OBJECT VOelPtGet V_P_((OBJECT ellipse, int index));
VI void VOelPtSet V_P_((OBJECT ellipse,  int index,
	 OBJECT NewControlPoint));
VI void VOelBox V_P_((OBJECT ellipse,  RECTANGLE *wvp,
	 register RECTANGLE *svp));
VI void VOelXfBox V_P_((OBJECT ellipse,  OBJECT xform,
	 RECTANGLE *svp));
VI BOOLPARAM VOelXformBox V_P_((OBJECT ellipse,  OBJECT xform,
				RECTANGLE *svp));
VI BOOLPARAM VOelIntersect V_P_((OBJECT ellipse,  OBJECT xform,
	 register RECTANGLE *vp));
VI BOOLPARAM VOelEval V_P_((OBJECT ellipse,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
VI OBJECT VOelGetSlotTable V_P_((OBJECT ellipse));
VI void VOelSetSlotTable V_P_((OBJECT ellipse,  OBJECT slots));
VI ADDRESS VOelDspEnv V_P_((OBJECT ellipse,  ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOdspenv.c */
VI void VOobClearDspEnv V_P_((OBJECT object));
VI RECTANGLE *VOobGetBoxDspEnv V_P_((OBJECT object));
VI ADDRESS VOobSetBoxDspEnv V_P_((RECTANGLE *new_obbox,
	 ADDRESS env_key));

/***
*** 
***/




/* VO/VOicon.c */
OBJECT VOicCreate V_P_((OBJECT pixmap,  OBJECT anchor_pt,
	 ATTRIBUTES *attributes,  ...));
OBJECT VOicClone V_P_((OBJECT icon));
OBJECT VOicReference V_P_((OBJECT icon));
void VOicDereference V_P_((OBJECT icon));
int VOicRefCount V_P_((OBJECT icon));
LONG VOicStatistic V_P_((int flag));
BOOLPARAM VOicTraverse V_P_((OBJECT icon,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOicBox V_P_((OBJECT icon,  RECTANGLE *wvp,  RECTANGLE *svp));
void VOicXfBox V_P_((OBJECT icon,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOicXformBox V_P_((OBJECT icon,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOicIntersect V_P_((OBJECT icon,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOicEval V_P_((OBJECT icon,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
void VOicAtGet V_P_((OBJECT icon,  register ATTRIBUTES *attributes));
void VOicAtSet V_P_((OBJECT icon,  register ATTRIBUTES *attributes));
OBJECT VOicPtGet V_P_((OBJECT icon, int index));
void VOicPtSet V_P_((OBJECT icon,  int index,  OBJECT NewControlPoint));
void VOicSave V_P_((OBJECT icon, OBJECT stream));
OBJECT VOicRetrieve V_P_((OBJECT stream));
void VOicGet V_P_((OBJECT icon, ...));
void VOicSet V_P_((OBJECT icon, ...));
OBJECT VOicGetSlotTable V_P_((OBJECT icon));
void VOicSetSlotTable V_P_((OBJECT icon, OBJECT slots));
ADDRESS VOicDspEnv V_P_((OBJECT icon, ADDRESS *dspenvp));
BOOLPARAM VOicValid V_P_((OBJECT icon));

/***
*** 
***/




/* VO/VOimage.c */
OBJECT VOimCreate V_P_((OBJECT pixmap,  OBJECT p1,  OBJECT p2,
	 ATTRIBUTES *attributes,  ...));
OBJECT VOimClone V_P_((OBJECT image));
OBJECT VOimReference V_P_((OBJECT image));
void VOimDereference V_P_((OBJECT image));
int VOimRefCount V_P_((OBJECT image));
LONG VOimStatistic V_P_((int flag));
BOOLPARAM VOimTraverse V_P_((OBJECT image,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOimBox V_P_((OBJECT image,  RECTANGLE *wvp,  RECTANGLE *svp));
void VOimXfBox V_P_((OBJECT image,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOimXformBox V_P_((OBJECT image,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOimIntersect V_P_((OBJECT image,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOimEval V_P_((OBJECT image,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
void VOimAtGet V_P_((OBJECT image,  register ATTRIBUTES *attributes));
void VOimAtSet V_P_((OBJECT image,  register ATTRIBUTES *attributes));
OBJECT VOimPtGet V_P_((OBJECT image, int index));
void VOimPtSet V_P_((OBJECT image,  int index,
	 OBJECT NewControlPoint));
void VOimSave V_P_((OBJECT image, OBJECT stream));
OBJECT VOimRetrieve V_P_((OBJECT stream));
void VOimGet V_P_((OBJECT image, ...));
void VOimSet V_P_((OBJECT image, ...));
void VOimScalePixmap V_P_((OBJECT image,  OBJECT xform,  double xscale,
	 double yscale));
OBJECT VOimGetSlotTable V_P_((OBJECT image));
void VOimSetSlotTable V_P_((OBJECT image, OBJECT slots));
ADDRESS VOimDspEnv V_P_((OBJECT image, ADDRESS *dspenvp));
BOOLPARAM VOimValid V_P_((OBJECT image));

/***
*** 
***/




/* VO/VOinput.c */
OBJECT VOinCreate V_P_((OBJECT p1,  OBJECT p2,
	 ATTRIBUTES *attributes));
LONG VOinStatistic V_P_((int Flag));
OBJECT VOinReference V_P_((OBJECT Input));
void VOinDereference V_P_((OBJECT Input));
int VOinRefCount V_P_((OBJECT Input));
OBJECT VOinClone V_P_((OBJECT Input));
BOOLPARAM VOinValid V_P_((OBJECT Input));
void VOinSave V_P_((OBJECT Input, OBJECT stream));
OBJECT VOinRetrieve V_P_((OBJECT stream));
BOOLPARAM VOinTraverse V_P_((OBJECT Input,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOinAtGet V_P_((OBJECT Input,  register ATTRIBUTES *attributes));
void VOinAtSet V_P_((OBJECT Input,  register ATTRIBUTES *attributes));
OBJECT VOinPtGet V_P_((OBJECT Input, int index));
void VOinPtSet V_P_((OBJECT Input,  int index,
	 OBJECT NewControlPoint));
void VOinGetVarList V_P_((OBJECT Input,  ADDRESS **VarList,
	 int *NumVars));
void VOinPutVarList V_P_((OBJECT Input,  ADDRESS *VarList,
	 int NumVars));
int VOinGetFlag V_P_((OBJECT Input, int FlagName));
void VOinPutFlag V_P_((OBJECT Input,  int FlagName,  int FlagValue));
OBJECT VOinTechnique V_P_((OBJECT Input,  OBJECT Technique));
ADDRESS VOinGetGenericData V_P_((OBJECT Input));
void VOinPutData V_P_((OBJECT Input, ADDRESS Data));
ADDRESS VOinGetData V_P_((OBJECT Input));
void VOinBox V_P_((OBJECT Input,  RECTANGLE *wvp,  RECTANGLE *svp));
void VOinXfBox V_P_((OBJECT Input,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOinXformBox V_P_((OBJECT Input,  OBJECT xform,  RECTANGLE *svp));
int VOinState V_P_((OBJECT Input, int State));
BOOLPARAM VOinIsDrawn V_P_((OBJECT Input));
BOOLPARAM VOinHasData V_P_((OBJECT Input));
ADDRESS VOinGetInternal V_P_((OBJECT Input,  int InternalObj));
BOOLPARAM VOinIntersect V_P_((OBJECT Input,  OBJECT xform,
	 register RECTANGLE *vp));
int VOinGetUpdateState V_P_((OBJECT Input));
int VOinNewDE V_P_((OBJECT Input));
int VOinFullDraw V_P_((OBJECT Input));
int VOinTakeInput V_P_((OBJECT Input));
BOOLPARAM VOinEval V_P_((OBJECT Input,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
void VOinDraw V_P_((OBJECT Input, DRAW_ENV *de));
void VOinRedraw V_P_((OBJECT Input, DRAW_ENV *de));
void VOinSimpleRedraw V_P_((OBJECT Input, DRAW_ENV *de));
void VOinUpdate V_P_((OBJECT Input));
int VOinHandleInput V_P_((OBJECT Input,  ADDRESS EventID,  int EventLabel,
	 OBJECT Location));
void VOinErase V_P_((OBJECT Input));
void VOinReset V_P_((OBJECT Input));
OBJECT VOinGetSlotTable V_P_((OBJECT Input));
void VOinSetSlotTable V_P_((OBJECT Input, OBJECT slots));
ADDRESS VOinDspEnv V_P_((OBJECT Input, ADDRESS *dspenvp));
int VNXRestoreVariables V_P_((OBJECT Input));
int VOinGetDrawInfo V_P_((OBJECT Input));

/***
*** 
***/




/* VO/VOintech.c */
OBJECT VOitCreate V_P_((ADDRESS format, OBJECT Template));
LONG VOitStatistic V_P_((int Flag));
OBJECT VOitReference V_P_((OBJECT InputTechnique));
void VOitDereference V_P_((OBJECT InputTechnique));
int VOitRefCount V_P_((OBJECT InputTechnique));
OBJECT VOitClone V_P_((OBJECT InputTechnique));
BOOLPARAM VOitValid V_P_((OBJECT InputTechnique));
void VOitSave V_P_((OBJECT InputTechnique, OBJECT stream));
OBJECT VOitRetrieve V_P_((OBJECT stream));
ADDRESS VOitGetInteraction V_P_((OBJECT InputTechnique));
ADDRESS VOitPutInteraction V_P_((OBJECT InputTechnique,
	 ADDRESS Format));
ADDRESS VOitGetOldInteraction V_P_((OBJECT InputTechnique));
ADDRESS VOitPutOldInteraction V_P_((OBJECT InputTechnique,
	 ADDRESS Format));
OBJECT VOitGetTemplate V_P_((OBJECT InputTechnique));
OBJECT VOitPutTemplate V_P_((OBJECT InputTechnique,
	 OBJECT Template));
void VOitPutTemplateName V_P_((OBJECT InputTechnique,
	 char *FileName));
char *VOitGetTemplateName V_P_((OBJECT InputTechnique));
VOITECHOFUNPTR VOitGetEchoFunction V_P_((OBJECT InputTechnique,
	 ADDRESS *Args,  int *Argbytes));
void VOitPutEchoFunction V_P_((OBJECT InputTechnique,
	 VOITECHOFUNPTR EchoFunction,  ADDRESS Args,  int Argbytes));
void VOitPutKeys V_P_((OBJECT InputTechnique,  int KeyType,
	 char *Keys));
char *VOitGetKeys V_P_((OBJECT InputTechnique,  int KeyType));
int VOitKeyOrigin V_P_((OBJECT InputTechnique,  int KeyType,
	 int LGflag));
void VOitGetList V_P_((OBJECT InputTechnique,  int *ListType,
	 ADDRESS *List,  int *NumItems));
void VOitPutList V_P_((OBJECT InputTechnique,  int ListType,
	 ADDRESS List,  int NumItems));
void VOitGetListFlags V_P_((OBJECT InputTechnique,  char **Flags,
	 int *NumFlags));
void VOitPutListFlags V_P_((OBJECT InputTechnique,  char *Flags,
	 int NumFlags));
void VOitGetListValues V_P_((OBJECT InputTechnique,  float **Values,
	 int *NumValues));
void VOitPutListValues V_P_((OBJECT InputTechnique,  float *Values,
	 int NumValues));
int VOitListStart V_P_((OBJECT InputTechnique,  int StartIndex));
OBJECT VOitInput V_P_((OBJECT InputTechnique,  OBJECT Input));
OBJECT VOitGetSlotTable V_P_((OBJECT InputTechnique));
void VOitSetSlotTable V_P_((OBJECT InputTechnique,  OBJECT slots));
BOOLPARAM VOitTraverse V_P_((OBJECT It,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));

/***
*** 
***/




/* VO/VOline.c */
VI OBJECT VOlnCreate V_P_((OBJECT pt1,  OBJECT pt2,
	 ATTRIBUTES *attributes));
VI LONG VOlnStatistic V_P_((int Flag));
VI OBJECT VOlnReference V_P_((OBJECT line));
VI void VOlnDereference V_P_((OBJECT line));
VI int VOlnRefCount V_P_((OBJECT line));
VI OBJECT VOlnClone V_P_((OBJECT line));
VI BOOLPARAM VOlnValid V_P_((OBJECT line));
VI void VOlnSave V_P_((OBJECT line, OBJECT stream));
VI OBJECT VOlnRetrieve V_P_((OBJECT stream));
VI BOOLPARAM VOlnTraverse V_P_((OBJECT line,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
VI void VOlnAtGet V_P_((OBJECT line,
	 register ATTRIBUTES *attributes));
VI void VOlnAtSet V_P_((OBJECT line,
	 register ATTRIBUTES *attributes));
VI OBJECT VOlnPtGet V_P_((OBJECT line, int index));
VI void VOlnPtSet V_P_((OBJECT line,  int index,
	 OBJECT NewControlPoint));
VI void VOlnBox V_P_((OBJECT line,  RECTANGLE *wvp,
	 register RECTANGLE *svp));
VI void VOlnXfBox V_P_((OBJECT line,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOlnXformBox V_P_((OBJECT line,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOlnIntersect V_P_((OBJECT line,  OBJECT xform,
	 register RECTANGLE *vp));
VI BOOLPARAM VOlnEval V_P_((OBJECT line,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
VI OBJECT VOlnGetSlotTable V_P_((OBJECT line));
VI void VOlnSetSlotTable V_P_((OBJECT line, OBJECT slots));
VI ADDRESS VOlnDspEnv V_P_((OBJECT line,  ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOlocation.c */
OBJECT VOloCreate V_P_((void));
LONG VOloStatistic V_P_((int Flag));
OBJECT VOloReference V_P_((OBJECT location));
int VOloRefCount V_P_((OBJECT location));
OBJECT VOloSetScreen V_P_((OBJECT location,  OBJECT screen));
OBJECT VOloScreen V_P_((OBJECT location));
void VOloDereference V_P_((OBJECT location));
void VOloDestroy V_P_((OBJECT location));
BOOLPARAM VOloValid V_P_((OBJECT location));
void VOloSetup V_P_((OBJECT location,  int key_pressed,  int xcoord,
	 int ycoord,  OBJECT viewport));
DV_POINT *VOloScpGet V_P_((OBJECT location));
OBJECT VOloWinEventPoll V_P_((int mode));
WINEVENT *VOloWinEventGet V_P_((OBJECT location));
OBJECT VOloWinEventSetup V_P_((OBJECT location,  WINEVENT *we,
	 OBJECT viewport));
ULONG VOloKeySym V_P_((OBJECT location));
char *VOloKeyString V_P_((OBJECT location));
int VOloButton V_P_((OBJECT location));
ULONG VOloState V_P_((OBJECT location));
ULONG VOloType V_P_((OBJECT location));
DV_POINT *VOloMaxPoint V_P_((OBJECT location));
RECTANGLE *VOloRegion V_P_((OBJECT location));
DV_POINT *VOloWcpGet V_P_((OBJECT location));
OBJECT VOloVpGet V_P_((OBJECT location));
int VOloKey V_P_((OBJECT location));

/***
*** 
***/




/* VO/VOdynutil.c */
void VOobDySet V_P_((OBJECT object, OBJECT dynamic));
OBJECT VOobDyGet V_P_((OBJECT object));
void VOobDyDelete V_P_((OBJECT object));
BOOLPARAM VOobDyIsSupported V_P_((OBJECT object,  int dyn_action));
BOOLPARAM VOobDyGetVisMask V_P_((OBJECT object,  int *mask_ptr));
void VOobDySetVisMask V_P_((OBJECT object,  int visibility_mask));
void VOobDyDelVisMask V_P_((OBJECT object));
void VOUdyAddRepairRegion V_P_((OBJECT object,
	 RECTANGLE *obj_extent));
void VOUdyRepairObjects V_P_((OBJECT viewport));

/* VO/VOfcntbles.c */

/* VO/VOgutils.c */
LONG VOgatPropFillVp V_P_((register RECTANGLE *r,  int fill_direction,
	 int fill_amount));
void VOgatPolyDraw V_P_((DV_POINT *pts,  int numpts,  ATTRIBUTES *attr,
	 RECTANGLE *obbox,  RECTANGLE *vp,  RECTANGLE **obsvps));
void VOgatGenDraw V_P_((VOGATFILLFUNPTR filldraw,  ADDRESS fillargs,
			VOGATEDGEFUNPTR edgedraw,  ADDRESS edgeargs,
			ATTRIBUTES *attr,  RECTANGLE *vp,
	 RECTANGLE **obsvps));
void VOgGetScreenVp V_P_(( OBJECT point1, OBJECT point2, OBJECT xform,
			  RECTANGLE *svp ));

/* VO/VOheap.c */
ADDRESS VOhpCreate V_P_((int OBJsize, int initial_count));
LONG VOhpMaxIndex V_P_((ADDRESS hdpaddr, LONG MaxIndex));
LONG VOhpStatistic V_P_((int Flag));
void VOhpDestroy V_P_((register ADDRESS hdp));
int VOhpAdd V_P_((ADDRESS hdpaddr, char *objectp));
void VOhpDelete V_P_((register ADDRESS hdp, int index));
ADDRESS VOhpAccess V_P_((register ADDRESS hdp, int index));
int VOhpNext V_P_((register ADDRESS hdp, int index));

/* VO/VOpixcnvrt.c */
BOOLPARAM VOpmPixrepFromFormat V_P_((PIXREP *pPixrep,  UBYTE *data,
	 int ldata,  char *func_name));
BOOLPARAM VOpmFormatFromPixrep V_P_((UBYTE *data,  int *pldata,
	 PIXREP *pPixrep,  char *func_name));
BOOLPARAM VOpmWriteInFormat V_P_((PIXREP *pPixrep,  char *fn,
	 V_PM_FORMAT_ENUM format,  char *func_name));
int VOpmGraphicsFormat V_P_((ADDRESS data));

/* VO/VOuDrwInfo.c */
DRAW_INFO *VOuDICreate V_P_((OBJECT p1,  OBJECT p2,  DRAW_ENV *de,
	 OBJECT obj,  OBJECT ForeColor,  OBJECT BackColor));
DRAW_INFO *VOuDIFree V_P_((DRAW_INFO *di));
DRAW_INFO *VOuDIGetLast V_P_((void));
void VOuDISetLast V_P_((DRAW_INFO *di));

/* VO/VOuDynCvt.c */
void VOuDySdConvert V_P_((OBJECT drawing,  OBJECT tt_object,
	 OBJECT *sdobject_ptr));
void VOuDyCoConvert V_P_((OBJECT object));

/* VO/VOuNmeSlts.c */
char *VOuObGetNameSlot V_P_((OBJECT object));
void VOuObSetNameSlot V_P_((OBJECT object, char *name));
void VOuObDeleteNameSlot V_P_((OBJECT object));
int VOuObMatchNameSlots V_P_((OBJECT start_obj,  int obj_type,
	 char *name,  OBJECT deque));

/* VO/VOutil.c */
void VOuAtInit V_P_((register ATTRIBUTES *attributes));
ATTRIBUTES *VOuAtDefault V_P_((register ATTRIBUTES *a));
ATTRIBUTES *VOuAttr V_P_((int i, ...));
void VOuClearDgData V_P_((OBJECT object));
BOOLPARAM VOuIsDynamic V_P_((OBJECT object));
BOOLPARAM VOuHasColorDynamics V_P_((OBJECT object));
BOOLPARAM VOuIsVisible V_P_((OBJECT obj));
OBJECT VOuDrRetrieve V_P_((ADDRESS filename));
void VOuDeleteDynamics V_P_((OBJECT drawing));
void VOuObMove V_P_((OBJECT object,  int flag,  int x,  int y));
void VOuDrListClear V_P_((void));
OBJECT VOuGetInList V_P_((OBJECT Candidates,  OBJECT xform,
	 RECTANGLE *vp));
void VOuGetMovePt V_P_((OBJECT InObject, DV_POINT *pt));
OBJECT VOuCreateVTextChar V_P_((char *fontname,  int cnum,  DV_POINT *orig,
	 int scale,  ATTRIBUTES *a));
void VOuVpEmpty V_P_((register RECTANGLE *vp));
void VOuVpBound V_P_((register RECTANGLE *vp,  OBJECT xform,
	 register RECTANGLE *boundvp));
void VOuVpObGet V_P_((OBJECT object,  OBJECT xform,
	 register RECTANGLE *vp));
void VOuVpPtsGet V_P_((DV_POINT *pts,  int numpts,  RECTANGLE *vp));
void VOuVpSort V_P_((register RECTANGLE *vp));
void VOuVpUnion V_P_((register RECTANGLE *vp1,
	 register RECTANGLE *vp2));
BOOLPARAM VOuVpIntersect V_P_((RECTANGLE *vp1,  RECTANGLE *vp2,
	 RECTANGLE *result_vp));
BOOLPARAM VOuVpVisible V_P_((register RECTANGLE *testvp,
	 RECTANGLE *invp,  RECTANGLE **obsvps));
BOOLPARAM VOuVpObscured V_P_((register RECTANGLE *vp,
	 RECTANGLE **obsvps));
OBJECT VOuXfDrFit V_P_((register RECTANGLE *vp,
	 BOOLPARAM all_visible));
OBJECT VOuXfStretchCreate V_P_((register RECTANGLE *r1,
	 register RECTANGLE *r2));
OBJECT VOuTxConvert V_P_((OBJECT txObject,  OBJECT drawing));
BOOLPARAM VOuXfDoesFlip V_P_((OBJECT xform));

/***
*** 
***/




/* VO/VOnode.c */
OBJECT VOnoCreate V_P_((OBJECT Edge1,  OBJECT Edge2,  OBJECT Geometry,
	 ATTRIBUTES *attributes));
LONG VOnoStatistic V_P_((int Flag));
OBJECT VOnoReference V_P_((OBJECT node));
void VOnoDereference V_P_((OBJECT node));
int VOnoRefCount V_P_((OBJECT node));
OBJECT VOnoClone V_P_((OBJECT node));
BOOLPARAM VOnoValid V_P_((OBJECT node));
void VOnoSave V_P_((OBJECT node, OBJECT stream));
OBJECT VOnoRetrieve V_P_((OBJECT stream));
BOOLPARAM VOnoTraverse V_P_((OBJECT node,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
OBJECT VOnoGetEdge V_P_((OBJECT node, LONG i));
OBJECT VOnoSetEdge V_P_((OBJECT node,  LONG i,  OBJECT NewEdge));
OBJECT VOnoAddEdge V_P_((OBJECT node,  LONG index,  OBJECT edge));
void VOnoDelEdge V_P_((OBJECT node, LONG index));
OBJECT VOnoGetGeometry V_P_((OBJECT node));
OBJECT VOnoSetGeometry V_P_((OBJECT node,  OBJECT NewGeometry));
LONG VOnoGetVisit V_P_((OBJECT node));
LONG VOnoSetVisit V_P_((OBJECT node, LONG NewCount));
void VOnoClearVisit V_P_((void));
BOOLPARAM VOnoGetMark V_P_((OBJECT node));
BOOLPARAM VOnoSetMark V_P_((OBJECT node,  BOOLPARAM NewMark));
void VOnoClearMark V_P_((void));
OBJECT VOnoGetSlotTable V_P_((OBJECT node));
void VOnoSetSlotTable V_P_((OBJECT node, OBJECT slots));
void VOnoAtGet V_P_((OBJECT node,  register ATTRIBUTES *attributes));
void VOnoAtSet V_P_((OBJECT node,  register ATTRIBUTES *attributes));
OBJECT VOnoPtGet V_P_((OBJECT node, int index));
void VOnoPtSet V_P_((OBJECT node,  int index,  OBJECT NewControlPoint));
void VOnoBox V_P_((OBJECT node,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
void VOnoXfBox V_P_((OBJECT node,  OBJECT xform,
	 register RECTANGLE *svp));
VI BOOLPARAM VOnoXformBox V_P_((OBJECT node,  OBJECT xform, RECTANGLE *svp));
BOOLPARAM VOnoIntersect V_P_((OBJECT node,  OBJECT xform,
	 RECTANGLE *vp));
BOOLPARAM VOnoEval V_P_((OBJECT node,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
ADDRESS VOnoDspEnv V_P_((OBJECT node, ADDRESS *dspenvp));

/***
*** 
***/


#if 0
/*  need a recursive definition for the function pointer used by
|   VOobEval().
*/
typedef DV_BOOL (*VOEVALSUBTYPEFUNPTR) V_P_((OBJECT object,
					     V_OB_EVAL_TYPE eval_type,
					     DRAW_ENV *de,
					     VOEVALSUBTYPEFUNPTR subtype_fcn));
#endif

/* VO/VOobject.c */
int VOobType V_P_((OBJECT object));
OBJECT VOobReference V_P_((OBJECT object));
void VOobDereference V_P_((OBJECT object));
int VOobRefCount V_P_((OBJECT object));
void VOobDestroy V_P_((OBJECT object));
BOOLPARAM VOobValid V_P_((OBJECT object));
OBJECT VOobClone V_P_((OBJECT object));
void VOobSave V_P_((OBJECT object, OBJECT stream));
OBJECT VOobRetrieve V_P_((OBJECT stream));
BOOLPARAM VOobTraverse V_P_((OBJECT object,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOobAtGet V_P_((OBJECT object,  ATTRIBUTES *attributes));
void VOobAtSet V_P_((OBJECT object,  ATTRIBUTES *attributes));
void VOobBox V_P_((OBJECT object,  RECTANGLE *wvp,  RECTANGLE *svp));
void VOobXfBox V_P_((OBJECT object,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOobXformBox V_P_((OBJECT object,  OBJECT xform,
			     RECTANGLE *svp));
BOOLPARAM VOobXformBoxPadded V_P_((OBJECT object,  OBJECT xform,
			     RECTANGLE *svp, INT padding));
BOOLPARAM VOobIntersect V_P_((OBJECT object,  OBJECT xform,
	 RECTANGLE *vp));
BOOLPARAM VOobEval V_P_((OBJECT object,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de,  BOOLFUNPTR subtype_fcn));
void VOobDraw V_P_((OBJECT object, DRAW_ENV *de));
void VOobRedraw V_P_((OBJECT object, DRAW_ENV *de));
void VOobErase V_P_((OBJECT object, DRAW_ENV *de));
DATUM VOobDataGet V_P_((OBJECT object));
DATUM VOobLastGet V_P_((OBJECT object));
DATUM_TYPE VOobTypeGet V_P_((OBJECT object));
OBJECT VOobPtGet V_P_((OBJECT object, int index));
void VOobPtSet V_P_((OBJECT object,  int index,
	 OBJECT NewControlPoint));
BOOLPARAM VOobGetSlotTable V_P_((OBJECT object,  OBJECT *SlotTable));
BOOLPARAM VOobSetSlotTable V_P_((OBJECT object,  OBJECT SlotTable));
ADDRESS VOobDspEnv V_P_((OBJECT object, ADDRESS *dspenvp));
int VOobHasSlot V_P_((OBJECT object, OBJECT slotkey ));
int VOobSetSlot V_P_((OBJECT object, OBJECT slotkey, LONG *value,
           ULONG *flags));
LONG VOobGetSlot V_P_((OBJECT object, OBJECT slotkey, LONG *value,
           ULONG *flags ));
BOOLPARAM VOobDeleteSlot V_P_((OBJECT object, OBJECT slotkey ));

/* VO/VOslotutls.c */
BOOLPARAM VOobSupportsSlots V_P_((OBJECT object));
int VOobHasSlot V_P_((OBJECT object, OBJECT slotkey));
LONG VOobGetSlot V_P_((OBJECT object,  OBJECT slotkey,  LONG *value,
	 ULONG *flags));
int VOobSetSlot V_P_((OBJECT object,  OBJECT slotkey,  LONG *value,
	 ULONG *flags));
BOOLPARAM VOobDeleteSlot V_P_((OBJECT object, OBJECT slotkey));
BOOLPARAM VOobCopySlots V_P_((OBJECT to_object,  OBJECT from_object));
int VOobNumSlots V_P_((OBJECT object));

/***
*** 
***/




/* VO/VOpixmap.c */
OBJECT VOpmCreate V_P_((char *file_name, ADDRESS data));
OBJECT VOpmClone V_P_((OBJECT pixmap));
OBJECT VOpmReference V_P_((OBJECT pixmap));
void VOpmDereference V_P_((OBJECT pixmap));
int VOpmRefCount V_P_((OBJECT pixmap));
LONG VOpmStatistic V_P_((int flag));
void VOpmSave V_P_((OBJECT pixmap, OBJECT stream));
OBJECT VOpmRetrieve V_P_((OBJECT stream));
void VOpmGet V_P_((OBJECT pixmap, ...));
void VOpmSet V_P_((OBJECT pixmap, ...));
OBJECT VOpmGetSlotTable V_P_((OBJECT pixmap));
void VOpmSetSlotTable V_P_((OBJECT pixmap, OBJECT slots));
BOOLPARAM VOpmValid V_P_((OBJECT pixmap));
ADDRESS VOpmToRaster V_P_((OBJECT pixmap, ...));
ADDRESS VOpmSetRasterMask V_P_((OBJECT pixmap,  ADDRESS raster,  ...));
BOOLPARAM VOpmWrite V_P_((OBJECT pixmap,  V_PM_FORMAT_ENUM format,
	 char *file_name));
void VOpmUpdateRaster V_P_((ADDRESS *rasterp,  OBJECT pixmap,
	 COLOR_XFORM *pixmap_transform,  OBJECT mask,
	 COLOR_XFORM *mask_transform,  RECTANGLE *prcVpNewss,
	 RECTANGLE *prcPixNewss,  RECTANGLE *prcPixSavss,  RECTANGLE *prcPixSavpp,
	 RECTANGLE *prcRasSavss,  BOOLPARAM fDirtyIn));
OBJECT VOpmFlip V_P_((OBJECT pixmap,  V_PM_FLIP_ENUM direction));
OBJECT VOpmRotate V_P_((OBJECT pixmap, int amount));
OBJECT VOpmMerge V_P_((OBJECT source,  RECTANGLE *rectp,  OBJECT dest,
	 DV_POINT *llp,  V_PM_MERGEMODE_ENUM mode,  OBJECT mask,
	 COLOR_XFORM *mask_transform));
OBJECT VOpmNewColorTable V_P_((OBJECT pixmap,  COLOR_TABLE *pclut,
	 BOOLPARAM fDither));
OBJECT VOpmResize V_P_((OBJECT pixmap,  int new_height,
	 int new_width));
OBJECT VOpmClip V_P_((OBJECT pixmap, RECTANGLE *rectp));
BOOLPARAM VOpmSetPixel V_P_((OBJECT pixmap,  DV_POINT *pointp,
	 ULONG value));
ULONG VOpmGetPixel V_P_((OBJECT pixmap,  DV_POINT *pointp));
BOOLPARAM VOpmBestColors V_P_((OBJECT *pixmaps,  int new_size,
	 COLOR_TABLE *pclut));
OBJECT VOpmCacheFind V_P_((char *file_name));
void VOpmCacheRemove V_P_((char *file_name));
void VOpmCacheRemoveAll V_P_((void));
BOOLPARAM VOpmBestXform V_P_((OBJECT pixmap,
	 COLOR_XFORM *transformp));
BOOLPARAM VOpmHasDummyPixels V_P_((OBJECT pixmap));

/***
*** 
***/




/* VO/VOpoint.c */
OBJECT VOptCreate V_P_((int format,  DV_COORD xcoord,  DV_COORD ycoord,
	 OBJECT ref_pt));
OBJECT VOptFCreate V_P_((int format,  double xcoord,  double ycoord,
	 OBJECT ref_pt));
LONG VOptStatistic V_P_((int Flag));
OBJECT VOptReference V_P_((OBJECT point));
void VOptDereference V_P_((OBJECT point));
int VOptRefCount V_P_((OBJECT point));
OBJECT VOptClone V_P_((OBJECT point));
BOOLPARAM VOptValid V_P_((OBJECT point));
void VOptSave V_P_((OBJECT point, OBJECT stream));
OBJECT VOptRetrieve V_P_((OBJECT stream));
BOOLPARAM VOptTraverse V_P_((OBJECT point,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
BOOLPARAM VOptIntersect V_P_((OBJECT point,  OBJECT xform,
	 register RECTANGLE *vp));
void VOptGet V_P_((OBJECT point,  register DV_POINT *wcs_pt,
	 register DV_POINT *pix_offset));
void VOptGetFloat V_P_((OBJECT point,  register FLOAT_POINT *wcs_pt,
	 register FLOAT_POINT *pix_offset));
void VOptGetParams V_P_((OBJECT point,  int *is_float,  int *is_world,
	 double *xcoord,  double *ycoord,  OBJECT *refpt));
void VOptXfGet V_P_((OBJECT point,  OBJECT xform,  register DV_POINT *pt));
void VOptXfGetFloat V_P_((OBJECT point,  OBJECT xform,
	 register FLOAT_POINT *pt));
BOOLPARAM VOptEval V_P_((OBJECT point,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
void VOptMoveFloat V_P_((OBJECT point,  int flag,  double deltax,
	 double deltay));
void VOptMove V_P_((OBJECT point,  int flag,  int deltax,  int deltay));
void VOptBox V_P_((OBJECT point, RECTANGLE *wvp, RECTANGLE *svp));
void VOptXfBox V_P_((OBJECT point,  OBJECT xform, RECTANGLE *svp));
BOOLPARAM VOptXformBox V_P_((OBJECT point,  OBJECT xform, RECTANGLE *svp));

/***
*** 
***/




/* VO/VOpolygon.c */
OBJECT VOpyCreate V_P_((OBJECT pt1,  OBJECT pt2,
	 ATTRIBUTES *attributes));
OBJECT VOpyPtlistCreate V_P_((OBJECT *pt,  int numpts,
	 ATTRIBUTES *attributes));
LONG VOpyStatistic V_P_((int Flag));
OBJECT VOpyReference V_P_((OBJECT polygon));
void VOpyDereference V_P_((OBJECT polygon));
int VOpyRefCount V_P_((OBJECT polygon));
OBJECT VOpyClone V_P_((OBJECT polygon));
BOOLPARAM VOpyValid V_P_((OBJECT polygon));
void VOpySave V_P_((OBJECT polygon, OBJECT stream));
OBJECT VOpyRetrieve V_P_((OBJECT stream));
BOOLPARAM VOpyTraverse V_P_((OBJECT polygon,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOpyAtGet V_P_((OBJECT polygon,
	 register ATTRIBUTES *attributes));
void VOpyAtSet V_P_((OBJECT polygon,
	 register ATTRIBUTES *attributes));
OBJECT VOpyPtGet V_P_((OBJECT polygon, int index));
void VOpyPtSet V_P_((OBJECT polygon,  int index,
	 OBJECT NewControlPoint));
void VOpyBox V_P_((OBJECT polygon,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
void VOpyXfBox V_P_((OBJECT polygon,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOpyXformBox V_P_((OBJECT polygon,  OBJECT xform,
				RECTANGLE *svp));
void VOpyPtAdd V_P_((OBJECT polygon,  int index,  OBJECT point));
void VOpyPtlistAdd V_P_((OBJECT polygon,  register int index,
	 register OBJECT *point,  int numpts));
void VOpyPtDelete V_P_((OBJECT polygon, int index));
BOOLPARAM VOpyIntersect V_P_((OBJECT polygon,  OBJECT xform,
	 RECTANGLE *vp));
BOOLPARAM VOpyEval V_P_((OBJECT polygon,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
OBJECT VOpyGetSlotTable V_P_((OBJECT polygon));
void VOpySetSlotTable V_P_((OBJECT polygon, OBJECT slots));
ADDRESS VOpyDspEnv V_P_((OBJECT polygon,  ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOrect.c */
OBJECT VOreCreate V_P_((OBJECT pt1,  OBJECT pt2,
	 ATTRIBUTES *attributes));
LONG VOreStatistic V_P_((int Flag));
OBJECT VOreReference V_P_((OBJECT rectangle));
void VOreDereference V_P_((OBJECT rectangle));
int VOreRefCount V_P_((OBJECT rectangle));
OBJECT VOreClone V_P_((OBJECT rectangle));
BOOLPARAM VOreValid V_P_((OBJECT rectangle));
void VOreSave V_P_((OBJECT rectangle, OBJECT stream));
OBJECT VOreRetrieve V_P_((OBJECT stream));
BOOLPARAM VOreTraverse V_P_((OBJECT rectangle,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOreAtGet V_P_((OBJECT rectangle,
	 register ATTRIBUTES *attributes));
void VOreAtSet V_P_((OBJECT rectangle,
	 register ATTRIBUTES *attributes));
OBJECT VOrePtGet V_P_((OBJECT rectangle, int index));
void VOrePtSet V_P_((OBJECT rectangle,  int index,
	 OBJECT NewControlPoint));
void VOreBox V_P_((OBJECT rectangle,  RECTANGLE *wvp,
	 register RECTANGLE *svp));
void VOreXfBox V_P_((OBJECT rectangle,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOreXformBox V_P_((OBJECT rectangle,  OBJECT xform,
				RECTANGLE *svp));
BOOLPARAM VOreIntersect V_P_((OBJECT rectangle,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOreEval V_P_((OBJECT rectangle,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
OBJECT VOreGetSlotTable V_P_((OBJECT rectangle));
void VOreSetSlotTable V_P_((OBJECT rectangle,  OBJECT slots));
ADDRESS VOreDspEnv V_P_((OBJECT rectangle,  ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOrule.c */
OBJECT VOruCreate V_P_((void));
LONG VOruStatistic V_P_((int Flag));
OBJECT VOruReference V_P_((OBJECT rule));
void VOruDereference V_P_((OBJECT rule));
int VOruRefCount V_P_((OBJECT rule));
OBJECT VOruClone V_P_((OBJECT rule));
BOOLPARAM VOruValid V_P_((OBJECT rule));
void VOruSave V_P_((OBJECT rule, OBJECT stream));
OBJECT VOruRetrieve V_P_((OBJECT stream));
void VOruGetInfo V_P_((OBJECT rule, ...));
void VOruGetInfoArgs V_P_((OBJECT rule,  int cond_action,  int *typep,
	 RULE_ARG **argp));
void VOruSetInfo V_P_((OBJECT rule, ...));
OBJECT VOruGetDqFromOb V_P_((OBJECT object));
int VOruNumInOb V_P_((OBJECT object));
OBJECT VOruGetFromOb V_P_((OBJECT object, int index));
BOOLPARAM VOruAddToOb V_P_((OBJECT object,  OBJECT rule,
	 int insert_index));
BOOLPARAM VOruDelFromOb V_P_((OBJECT object, OBJECT rule));

/* VO/VOruleutil.c */
void VOUruFreeCond V_P_((RULE_CONDITION *cond,  LONG rule,  int index));
void VOUruFreeAction V_P_((RULE_ACTION *action,  LONG rule,
	 int index));
void VOUruRefAction V_P_((RULE_ACTION *action,  LONG rule,  int index));
void VOUruRefCond V_P_((RULE_CONDITION *cond,  LONG rule,  int index));
void VOUruCopyCond V_P_((RULE_CONDITION *to_cond,
	 RULE_CONDITION *from_cond,  LONG rule));
void VOUruCopyAction V_P_((RULE_ACTION *to_action,
	 RULE_ACTION *from_action,  LONG rule));
void VOUruGetEventTypes V_P_((LONG obj,  int *has_pick_event,
	 int *has_event_used_event,  int *has_done_event,  int *has_accept_event,
	 int *has_cancel_event));
BOOLPARAM VOUruAdjustEvents V_P_((LONG obj, LONG rule));
void VOUruDelete V_P_((LONG obj,  int index,
	 DV_BOOL marked_array[ 100 ]));
int VOUruMove V_P_((LONG obj,  int rule_index,  LONG marked_obj,
	 DV_BOOL marked_array[ 100 ]));
int VOUruCopy V_P_((LONG obj,  int rule_index,  LONG marked_obj,
	 DV_BOOL marked_array[ 100 ]));
void VOUruSwitchDsv V_P_((LONG rule,  ADDRESS old_dsv,
	 ADDRESS new_dsv));
void VOUruChangeDsv V_P_((LONG rule,  ADDRESS old_dsv,
	 ADDRESS new_dsv));
void VOUruBindDsv V_P_((LONG dr));
void VOUruConvert V_P_((LONG dr));

/***
*** 
***/




/* VO/VOscreen.c */
OBJECT VOscDevnumToScreen V_P_((int devnum));
OBJECT VOscOpenClutSet V_P_((char *device_name,  char *clutfile,  ...));
OBJECT VOscOpenClut V_P_((char *device_name,  char *clutfile));
OBJECT VOscOpenSet V_P_((char *device_name, ...));
OBJECT VOscOpen V_P_((char *device_name));
void VOscClose V_P_((void));
BOOLPARAM VOscValid V_P_((OBJECT scr));
OBJECT VOscSelect V_P_((OBJECT screen));
OBJECT VOscCurrent V_P_((void));
void VOscVpAdd V_P_((OBJECT vp_obj));
void VOscVpDelete V_P_((OBJECT vp_obj));
OBJECT VOscVpFind V_P_((DV_POINT *p));
OBJECT VOscGetVp V_P_((int screen, DV_POINT *p));
void VOscVpFront V_P_((OBJECT vp_obj));
void VOscVpBack V_P_((OBJECT vp_obj));
OBJECT VOscVpFirst V_P_((void));
OBJECT VOscVpNext V_P_((OBJECT vp_obj));
OBJECT VOscVpPrior V_P_((OBJECT vp_obj));
LONG VOscVpVersion V_P_((int update_version));
OBJECT VOscVpDeque V_P_((void));
OBJECT VOscForecolor V_P_((OBJECT clr_obj));
OBJECT VOscDefForecolor V_P_((OBJECT clr_obj));
OBJECT VOscBackcolor V_P_((OBJECT clr_obj));
OBJECT VOscDefBackcolor V_P_((OBJECT clr_obj));
OBJECT VOscLocate V_P_((void));
void VOscUnlocate V_P_((OBJECT location));
void VOscOpenPoll V_P_((void));
void VOscClosePoll V_P_((void));
OBJECT VOscPoll V_P_((void));
void VOscPurgeEvents V_P_((void));
OBJECT VOscWinEventMask V_P_((ULONG mask, ULONG altmask));
OBJECT VOscWinEventPoll V_P_((int mode));
OBJECT VOscLoSet V_P_((DV_POINT *p));
void VOscScToNdc V_P_((register DV_POINT *sp,
	 register FLOAT_POINT *ndcp));
void VOscNdcToSc V_P_((register FLOAT_POINT *ndcp,
	 register DV_POINT *sp));
void VOscReset V_P_((void));
void VOscRedraw V_P_((RECTANGLE *redraw_vp));
void VOscDraw V_P_((RECTANGLE *draw_vp));
DV_POINT *VOscSize V_P_((void));
char *VOscDeviceName V_P_((OBJECT screen));
OBJECT VOscLocationObject V_P_((OBJECT screen));

#ifdef WINNT
 void VOprReset(void);
#endif 
/***
*** 
***/




/* VO/VOsubdrwng.c */
OBJECT VOsdCreate V_P_((char *filename,  VIEW view,  OBJECT anchorpt,
	 double scale,  ATTRIBUTES *attributes));
LONG VOsdStatistic V_P_((int Flag));
OBJECT VOsdReference V_P_((OBJECT subdrawing));
void VOsdDereference V_P_((OBJECT subdrawing));
int VOsdRefCount V_P_((OBJECT subdrawing));
OBJECT VOsdClone V_P_((OBJECT subdrawing));
BOOLPARAM VOsdValid V_P_((OBJECT subdrawing));
void VOsdSave V_P_((OBJECT subdrawing, OBJECT stream));
OBJECT VOsdRetrieve V_P_((OBJECT stream));
BOOLPARAM VOsdTraverse V_P_((OBJECT subdrawing,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
BOOLPARAM VOsdTopTraverse V_P_((OBJECT subdrawing,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOsdAtGet V_P_((OBJECT subdrawing,  ATTRIBUTES *attributes));
void VOsdAtSet V_P_((OBJECT subdrawing,  ATTRIBUTES *attributes));
OBJECT VOsdPtGet V_P_((OBJECT subdrawing, int index));
void VOsdPtSet V_P_((OBJECT subdrawing,  int index,
	 OBJECT NewControlPoint));
OBJECT VOsdGetXform V_P_((OBJECT subdrawing));
void VOsdBox V_P_((OBJECT subdrawing,  RECTANGLE *wvp,
	 RECTANGLE *svp));
void VOsdXfBox V_P_((OBJECT subdrawing,  OBJECT dr_xform,
	 RECTANGLE *svp));
VI BOOLPARAM VOsdXformBox V_P_((OBJECT subdrawing,  OBJECT dr_xform,
				RECTANGLE *svp));
BOOLPARAM VOsdIntersect V_P_((OBJECT subdrawing,  OBJECT xform,
	 RECTANGLE *vp));
BOOLPARAM VOsdEval V_P_((OBJECT subdrawing,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de,  BOOLFUNPTR subtype_fcn));
BOOLPARAM VOsdEvalObject V_P_((OBJECT subdrawing,  OBJECT object,
	 V_OB_EVAL_TYPE eval_type,  DRAW_ENV *de,  BOOLFUNPTR subtype_fcn,
	 OBJECT *sd_list));
double VOsdRotate V_P_((OBJECT subdrawing, double angle));
double VOsdXScale V_P_((OBJECT subdrawing, double scale));
double VOsdYScale V_P_((OBJECT subdrawing, double scale));
double VOsdScale V_P_((OBJECT subdrawing, double scale));
void VOsdGetXformParams V_P_((OBJECT subdrawing,  double *angle,
	 double *xscale,  double *yscale));
void VOsdSetXformParams V_P_((OBJECT subdrawing,  double *angle,
	 double *xscale,  double *yscale));
char *VOsdFilename V_P_((OBJECT subdrawing));
BOOLPARAM VOsdHasDynamics V_P_((OBJECT subdrawing));
VIEW VOsdViGet V_P_((OBJECT subdrawing));
BOOLPARAM VOsdViKeep V_P_((OBJECT subdrawing,  int save_the_view));
void VOsdViSet V_P_((OBJECT subdrawing,  char *filename,  VIEW view));
VIEW VOsdViReplace V_P_((OBJECT subdrawing,  char *filename,
	 VIEW view));
void VOsdViDynReplace V_P_((OBJECT subdrawing,  VIEW view,
	 BOOLPARAM active_tt,  int dyn_flag));
OBJECT VOsdDrGet V_P_((OBJECT subdrawing));
BOOLPARAM VOsdDrKeep V_P_((OBJECT subdrawing,  int save_the_drawing));
void VOsdDrSet V_P_((OBJECT subdrawing,  char *filename,
	 OBJECT drawing));
OBJECT VOsdGetSlotTable V_P_((OBJECT subdrawing));
void VOsdSetSlotTable V_P_((OBJECT subdrawing,  OBJECT slots));
ADDRESS VOsdDspEnv V_P_((OBJECT subdrawing,  ADDRESS *dspenvp));
BOOLPARAM VOsdMapVars V_P_((OBJECT subdrawing));
BOOLPARAM VOsdUnMapVars V_P_((OBJECT subdrawing));
int VOsdGetDynamicFlag V_P_((OBJECT subdrawing));
void VOsdSetDynamicFlag V_P_((OBJECT subdrawing,  int flag));
int VOsdGetDsvMapping V_P_((OBJECT subdrawing,  int index,
	 DSVAR *src_dsvar,  DSVAR *dst_dsvar));
int VOsdSetDsvMapping V_P_((OBJECT subdrawing,  DSVAR src_dsvar,
	 DSVAR dst_dsvar));
OBJECT VOsdGetSelectedObject V_P_((OBJECT subdrawing,  OBJECT location,
	 OBJECT xform,  int check_mode));
OBJECT VOsdGetSelectedSubObject V_P_((OBJECT subdrawing,
	 OBJECT location,  OBJECT xform,  int check_mode));
void VOsdPoolReset V_P_((void));
void VOsdPoolRemove V_P_((OBJECT subdrawing));
BOOLPARAM VOsdPoolFnmRemove V_P_((char *filename));
BOOLPARAM VOsdHasDummyView V_P_((OBJECT subdrawing));

/***
*** 
***/



/* VO/VOsftext.c */
void VOsfFitRect V_P_((OBJECT object,  RECTANGLE *rect,  float *width,
	 float *height,  DV_POINT *cp));
OBJECT VOsfCreate V_P_((char *string,  OBJECT anchor_pt,
	 ATTRIBUTES *a));
LONG VOsfStatistic V_P_((int Flag));
OBJECT VOsfReference V_P_((OBJECT sftext));
void VOsfDereference V_P_((OBJECT sftext));
int VOsfRefCount V_P_((OBJECT sftext));
OBJECT VOsfClone V_P_((OBJECT sftext));
BOOLPARAM VOsfValid V_P_((OBJECT sftext));
void VOsfSave V_P_((OBJECT sftext, OBJECT stream));
OBJECT VOsfRetrieve V_P_((OBJECT stream));
BOOLPARAM VOsfTraverse V_P_((OBJECT sftext,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOsfAtGet V_P_((OBJECT sftext,  register ATTRIBUTES *attributes));
void VOsfAtSet V_P_((OBJECT sftext,  register ATTRIBUTES *attributes));
char *VOsfGetString V_P_((OBJECT sftext));
void VOsfSetString V_P_((OBJECT sftext, char *newstring));
OBJECT VOsfPtGet V_P_((OBJECT sftext, int index));
void VOsfPtSet V_P_((OBJECT sftext,  int index,
	 OBJECT NewControlPoint));
void VOsfGetBound V_P_((OBJECT sftext,  int *hw,  int *hh,  int *vw,
	 int *vh));
void VOsfBox V_P_((OBJECT sftext,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
void VOsfXfBox V_P_((OBJECT sf,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOsfXformBox V_P_((OBJECT sf,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOsfIntersect V_P_((OBJECT sftext,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOsfEval V_P_((OBJECT sftext,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
OBJECT VOsfGetSlotTable V_P_((OBJECT sftext));
void VOsfSetSlotTable V_P_((OBJECT sftext, OBJECT slots));
ADDRESS VOsfDspEnv V_P_((OBJECT sftext, ADDRESS *dspenvp));
BOOLPARAM VOsfpt_to_scs(OBJECT sftext, float *width, float *height);


/* VO/VOslotkey.c */
OBJECT VOskDeclare V_P_((char *argKeyName, ...));
OBJECT VOskFind V_P_((char *KeyName));
LONG VOskStatistic V_P_((int Flag));
OBJECT VOskReference V_P_((OBJECT slotkey));
void VOskDereference V_P_((OBJECT slotkey));
int VOskRefCount V_P_((OBJECT slotkey));
OBJECT VOskClone V_P_((OBJECT slotkey));
BOOLPARAM VOskValid V_P_((OBJECT slotkey));
void VOskSave V_P_((OBJECT slotkey, OBJECT stream));
OBJECT VOskRetrieve V_P_((OBJECT stream));
void VOskGetType V_P_((OBJECT slotkey,  int *TypeFlag,  LONG *size));
char *VOskGetKeyName V_P_((OBJECT slotkey));
BOOLPARAM VOskCallMethod V_P_((OBJECT slotkey,  int method,  ...));

/***
*** 
***/


/* should this definition be here or in a separate header file? */
/* typedef  ADDRESS (*VOSMREALLOCFUN)V_P_((char *ptr, unsigned int size));*/


/* VO/VOstream.c */
OBJECT VOsmCreate V_P_((int access_mode,  FILE *filep,  char *bufferp,
	 int buffer_size,  VOSMREALLOCFUNPTR reallocp));
OBJECT VOsmFOpen V_P_((char *filename, int access_mode));
void VOsmQueryBuf V_P_((OBJECT stream,  char **bufferpp,  int *sizep));
LONG VOsmStatistic V_P_((int flag));
void VOsmClose V_P_((OBJECT stream));
void VOsmCloseBuf V_P_((OBJECT stream,  char **bufferpp,  int *sizep));
BOOLPARAM VOsmValid V_P_((OBJECT stream));
int VOsmRead V_P_((OBJECT stream,  char *buffer,  int numbytes));
int VOsmArrayRead V_P_((OBJECT stream,  char *buffer,  int bytes_per_entry,  int num_entries));
void VOsmNumRead V_P_((OBJECT stream,  ADDRESS numberp,  int type));
void VOsmNumArrayRead V_P_((OBJECT stream,  ADDRESS numberp,  int type,  int num_entries));
OBJECT VOsmObRead V_P_((OBJECT stream));
char *VOsmStrRead V_P_((OBJECT stream));
void VOsmAddEntry V_P_((OBJECT stream,  OBJECT key,  OBJECT value));
OBJECT VOsmGetEntry V_P_((OBJECT stream, OBJECT key));
BOOLPARAM VOsmHasEntry V_P_((OBJECT stream, OBJECT key));
void VOsmWrite V_P_((OBJECT stream,  char *buffer,  int numbytes));
void VOsmNumWrite V_P_((OBJECT stream,  ADDRESS numberp,  int type));
void VOsmObWrite V_P_((OBJECT stream, OBJECT object));
void VOsmStrWrite V_P_((OBJECT stream, char *string));
OBJECT VOsmFCreate V_P_((FILE *filep,  int access_mode,
	 char *filename));
void VOsmRAddEntry V_P_((OBJECT stream,  OBJECT key,  OBJECT value));
void VOsmWAddEntry V_P_((OBJECT stream,  OBJECT key,  OBJECT value));
BOOLPARAM VOsmRHasEntry V_P_((OBJECT stream, OBJECT key));
BOOLPARAM VOsmWHasEntry V_P_((OBJECT stream, OBJECT key));
OBJECT VOsmRGetEntry V_P_((OBJECT stream, OBJECT key));
OBJECT VOsmWGetEntry V_P_((OBJECT stream, OBJECT key));

/***
*** 
***/




/* VO/VOslotable.c */
VI OBJECT VOstCreate V_P_((int initial_size));
VI LONG VOstStatistic V_P_((int Flag));
VI OBJECT VOstReference V_P_((OBJECT slottable));
VI void VOstDereference V_P_((OBJECT slottable));
VI int VOstRefCount V_P_((OBJECT slottable));
VI OBJECT VOstClone V_P_((OBJECT slottable));
VI BOOLPARAM VOstValid V_P_((OBJECT slottable));
VI void VOstSave V_P_((OBJECT slottable, OBJECT stream));
VI OBJECT VOstRetrieve V_P_((OBJECT stream));
VI int VOstSetEntry V_P_((OBJECT slottable,  OBJECT slotkey,  LONG *value,
	 ULONG *flags));
VI LONG VOstGetEntry V_P_((OBJECT slottable,  OBJECT slotkey,
	 LONG *value,  ULONG *flags));
VI BOOLPARAM VOstDeleteEntry V_P_((OBJECT slottable,
	 OBJECT slotkey));
VI int VOstSize V_P_((OBJECT slottable));
VI void VOstAttachToObject V_P_((OBJECT slottable,  OBJECT object));
VI void VOstDetachFromObject V_P_((OBJECT slottable,  OBJECT object));
VI OBJECT VOstCloneForObject V_P_((OBJECT slottable,  OBJECT object));
VI OBJECT VOstGetParentObject V_P_((OBJECT slottable));

/***
*** 
***/




/* VO/VOthrshold.c */
OBJECT VOttCreate V_P_((OBJECT vardesc,  DATUM_TYPE type,  ...));
OBJECT VOttDatCreate V_P_((OBJECT vardesc,  DATUM_TYPE type,
	 DATUM datum));
OBJECT VOttObCreate V_P_((OBJECT vardesc, OBJECT object));
OBJECT VOttStrCreate V_P_((OBJECT vardesc, char *string));
LONG VOttStatistic V_P_((int Flag));
OBJECT VOttReference V_P_((OBJECT thresh_table));
void VOttDereference V_P_((OBJECT thresh_table));
int VOttRefCount V_P_((OBJECT thresh_table));
OBJECT VOttClone V_P_((OBJECT thresh_table));
BOOLPARAM VOttValid V_P_((OBJECT thresh_table));
void VOttSave V_P_((OBJECT thresh_table, OBJECT stream));
OBJECT VOttRetrieve V_P_((OBJECT stream));
BOOLPARAM VOttTraverse V_P_((OBJECT thresh_table,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOttBox V_P_((OBJECT thresh_table,  RECTANGLE *wvp,
	 RECTANGLE *svp));
void VOttXfBox V_P_((OBJECT thresh_table,  OBJECT xform,
	 RECTANGLE *svp));
VI BOOLPARAM VOttXformBox V_P_((OBJECT thresh_table,  OBJECT xform,
				RECTANGLE *svp));
BOOLPARAM VOttIntersect V_P_((OBJECT thresh_table,  OBJECT xform,
	 RECTANGLE *vp));
OBJECT VOttVd V_P_((OBJECT thresh_table));
int VOttSize V_P_((OBJECT thresh_table));
void VOttAddThresh V_P_((OBJECT thresh_table,  int thresh,  DATUM out));
void VOttDelThresh V_P_((OBJECT thresh_table, int thresh));
void VOttGetThresh V_P_((OBJECT thresh_table,  int index,  int *thresh,
	 DATUM *out));
int VOttHasThresh V_P_((OBJECT thresh_table, int thresh));
void VOttSetDatum V_P_((OBJECT thresh_table,  int thresh,  DATUM out));
void VOttScale V_P_((OBJECT thresh_table,  double scale_factor,
	 double offset));
DATUM VOttDataGet V_P_((OBJECT thresh_table));
DATUM VOttLastGet V_P_((OBJECT thresh_table));
DATUM_TYPE VOttTypeGet V_P_((OBJECT thresh_table));
void VOttUpdate V_P_((OBJECT thresh_table));
void VOttReset V_P_((OBJECT thresh_table));
OBJECT VOttGetSlotTable V_P_((OBJECT thresh_table));
void VOttSetSlotTable V_P_((OBJECT thresh_table,  OBJECT slots));
BOOLPARAM VOttEval V_P_((OBJECT thresh_table,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de,  BOOLFUNPTR subtype_fcn));

/***
*** 
***/




/* VO/VOtext.c */
VI OBJECT VOtxCreate V_P_((char *string,  OBJECT anchorpt,
	 ATTRIBUTES *attributes));
VI LONG VOtxStatistic V_P_((int Flag));
VI OBJECT VOtxReference V_P_((OBJECT text));
VI void VOtxDereference V_P_((OBJECT text));
VI int VOtxRefCount V_P_((OBJECT text));
VI OBJECT VOtxClone V_P_((OBJECT text));
VI BOOLPARAM VOtxValid V_P_((OBJECT text));
VI void VOtxSave V_P_((OBJECT text, OBJECT stream));
VI OBJECT VOtxRetrieve V_P_((OBJECT stream));
VI BOOLPARAM VOtxTraverse V_P_((OBJECT text,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
VI void VOtxAtGet V_P_((OBJECT text,
	 register ATTRIBUTES *attributes));
VI void VOtxAtSet V_P_((OBJECT text,
	 register ATTRIBUTES *attributes));
VI char *VOtxGetString V_P_((OBJECT text));
VI void VOtxSetString V_P_((OBJECT text, char *newstring));
VI OBJECT VOtxPtGet V_P_((OBJECT text, int index));
VI void VOtxPtSet V_P_((OBJECT text,  int index,
	 OBJECT NewControlPoint));
VI void VOtxBox V_P_((OBJECT text,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
VI void VOtxXfBox V_P_((OBJECT text,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOtxXformBox V_P_((OBJECT text,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOtxIntersect V_P_((OBJECT text,  OBJECT xform,
	 register RECTANGLE *vp));
VI BOOLPARAM VOtxEval V_P_((OBJECT text,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
VI OBJECT VOtxGetSlotTable V_P_((OBJECT text));
VI void VOtxSetSlotTable V_P_((OBJECT text, OBJECT slots));
VI ADDRESS VOtxDspEnv V_P_((OBJECT text,  ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOvd.c */
OBJECT VOvdCreate V_P_((ADDRESS dsvar,  int type,  DATUM statval));
LONG VOvdStatistic V_P_((int Flag));
OBJECT VOvdReference V_P_((OBJECT vardesc));
void VOvdDereference V_P_((OBJECT vardesc));
int VOvdRefCount V_P_((OBJECT vardesc));
OBJECT VOvdClone V_P_((OBJECT vardesc));
BOOLPARAM VOvdValid V_P_((OBJECT vardesc));
void VOvdSave V_P_((OBJECT vardesc, OBJECT stream));
OBJECT VOvdRetrieve V_P_((OBJECT stream));
ADDRESS VOvdGetVdp V_P_((OBJECT vardesc));
ADDRESS VOvdAddress V_P_((OBJECT vardesc));
BOOLPARAM VOvdSetInfo V_P_((OBJECT vardesc, ...));
BOOLPARAM VOvdGetInfo V_P_((OBJECT vardesc, ...));
void VOvdSwitch V_P_((OBJECT vardesc, VAR_DESC *vdp));
void VOvdReset V_P_((OBJECT vardesc));
BOOLPARAM VOvdChanged V_P_((OBJECT vardesc));
int VOvdType V_P_((OBJECT vardesc));
OBJECT VOvdColor V_P_((OBJECT vardesc));
char *VOvdDigits V_P_((OBJECT vardesc));
DATUM VOvdSvGet V_P_((OBJECT vardesc));
void VOvdSvPut V_P_((OBJECT vardesc, DATUM statval));
DATUM VOvdDvGet V_P_((OBJECT vardesc));

/***
*** 
***/




/* VO/VOviewport.c */
INT VOvpCheckGridSpacing V_P_((OBJECT viewport));
OBJECT VOvpCreate V_P_((char *device,  FLOAT_POINT *llp,
	 FLOAT_POINT *urp,  int HasFrame));
OBJECT VOvpDeltaCreate V_P_((char *device,  FLOAT_POINT *anchorp,
	 FLOAT_POINT *deltap,  int HasFrame));
LONG VOvpStatistic V_P_((int Flag));
void VOvpDestroy V_P_((OBJECT viewport));
OBJECT VOvpReference V_P_((OBJECT viewport));
void VOvpDereference V_P_((OBJECT viewport));
BOOLPARAM VOvpValid V_P_((OBJECT viewport));
BOOLPARAM VOvpDrAttach V_P_((OBJECT viewport,  OBJECT dr_obj,
	 OBJECT xf_obj));
void VOvpDrDetach V_P_((OBJECT viewport));
OBJECT VOvpDrGet V_P_((OBJECT viewport));
void VOvpSelect V_P_((OBJECT viewport));
OBJECT VOvpGetScreen V_P_((OBJECT viewport));
RECTANGLE *VOvpInvpGet V_P_((OBJECT viewport));
RECTANGLE *VOvpOutvpGet V_P_((OBJECT viewport));
RECTANGLE **VOvpObsvpGet V_P_((OBJECT viewport));
RECTANGLE **VOvpObdvpGet V_P_((OBJECT viewport));
BOOLPARAM VOvpPtVisible V_P_((OBJECT viewport, DV_POINT *pt));
void VOvpDraw V_P_((OBJECT viewport));
void VOvpRedraw V_P_((OBJECT viewport, RECTANGLE *clipvp));
void VOvpRedrawWithBg V_P_((OBJECT viewport,  RECTANGLE *clipvp,
	 int erase_flag));
void VOvpEraseBg V_P_((OBJECT viewport));
void VOvpErase V_P_((OBJECT viewport));
void VOvpDrawObject V_P_((OBJECT viewport,  OBJECT object,
	 BOOLFUNPTR draw_fcn));
void VOvpRedrawObject V_P_((OBJECT viewport,  OBJECT object,
	 RECTANGLE *clipvp,  BOOLFUNPTR draw_fcn));
void VOvpEraseObject V_P_((OBJECT viewport,  OBJECT object,
	 BOOLFUNPTR erase_fcn));
BOOLPARAM VOvpEval V_P_((OBJECT viewport,  V_OB_EVAL_TYPE eval_type,
	 RECTANGLE *clipvp,  BOOLFUNPTR subtype_fcn));
BOOLPARAM VOvpEvalObject V_P_((OBJECT viewport,  OBJECT object,
	 V_OB_EVAL_TYPE eval_type,  RECTANGLE *clipvp,
	 BOOLFUNPTR subtype_fcn));
BOOLPARAM VOvpFastEvalObject V_P_((OBJECT viewport,  OBJECT object,
	 V_OB_EVAL_TYPE eval_type,  RECTANGLE *clipvp,  BOOLFUNPTR subtype_fcn,
	 BOOLPARAM skip_sd_check));
void VOvpUpdateVis V_P_((OBJECT viewport));
void VOvpResize V_P_((OBJECT viewport, RECTANGLE *clipvp));
BOOLPARAM VOvpEvalExcept V_P_((OBJECT viewport,
	 V_OB_EVAL_TYPE eval_type,  RECTANGLE *region,  OBJECT target_obj,
	 int position));
void VOvpDrawBackground V_P_((OBJECT viewport,  RECTANGLE *region));
void VOvpDrawBound V_P_((OBJECT viewport,  RECTANGLE *clipvp));
void VOvpDrawGrid V_P_((OBJECT viewport,  RECTANGLE *clipvp));
OBJECT VOvpXfGet V_P_((OBJECT viewport, int flag));
void VOvpXfSet V_P_((OBJECT viewport, OBJECT dr_xform));
BOOLPARAM VOvpWcpGet V_P_((OBJECT viewport,  register DV_POINT *scp,
	 DV_POINT *wcp));
void VOvpCenter V_P_((OBJECT viewport, DV_POINT *center));
BOOLPARAM VOvpZoom V_P_((OBJECT viewport, double scale));
void VOvpChange V_P_((OBJECT viewport,  FLOAT_POINT *llp,
	 FLOAT_POINT *urp));
int VOvpGetGrid V_P_((OBJECT viewport, ...));
int VOvpSetGrid V_P_((OBJECT viewport, ...));
void VOvpGrid V_P_((OBJECT viewport, BOOLPARAM flag));
void VOvpNearestGridPt V_P_((OBJECT viewport,  DV_POINT *inp,
	 register DV_POINT *outp));
int VOvpGridSpacing V_P_((OBJECT viewport));
BOOLPARAM VOvpInitialDraw V_P_((OBJECT viewport,
	 DV_BOOL *flag_value));

/***
*** 
***/




/* VO/VOvtext.c */
void VOvtFitRect V_P_((OBJECT object,  RECTANGLE *rect,  float *width,
	 float *height,  DV_POINT *cp));
OBJECT VOvtCreate V_P_((char *string,  OBJECT anchor_pt,
	 ATTRIBUTES *a));
LONG VOvtStatistic V_P_((int Flag));
OBJECT VOvtReference V_P_((OBJECT vtext));
void VOvtDereference V_P_((OBJECT vtext));
int VOvtRefCount V_P_((OBJECT vtext));
OBJECT VOvtClone V_P_((OBJECT vtext));
BOOLPARAM VOvtValid V_P_((OBJECT vtext));
void VOvtSave V_P_((OBJECT vtext, OBJECT stream));
OBJECT VOvtRetrieve V_P_((OBJECT stream));
BOOLPARAM VOvtTraverse V_P_((OBJECT vtext,  VOOBTRAVERSEFUNPTR test,
	 ADDRESS testargs));
void VOvtAtGet V_P_((OBJECT vtext,  register ATTRIBUTES *attributes));
void VOvtAtSet V_P_((OBJECT vtext,  register ATTRIBUTES *attributes));
char *VOvtGetString V_P_((OBJECT vtext));
void VOvtSetString V_P_((OBJECT vtext, char *newstring));
OBJECT VOvtPtGet V_P_((OBJECT vtext, int index));
void VOvtPtSet V_P_((OBJECT vtext,  int index,
	 OBJECT NewControlPoint));
void VOvtGetBound V_P_((OBJECT vtext,  int *hw,  int *hh,  int *vw,
	 int *vh));
void VOvtBox V_P_((OBJECT vtext,  register RECTANGLE *wvp,
	 register RECTANGLE *svp));
void VOvtXfBox V_P_((OBJECT vt,  OBJECT xform,  RECTANGLE *svp));
VI BOOLPARAM VOvtXformBox V_P_((OBJECT vt,  OBJECT xform,  RECTANGLE *svp));
BOOLPARAM VOvtIntersect V_P_((OBJECT vtext,  OBJECT xform,
	 register RECTANGLE *vp));
BOOLPARAM VOvtEval V_P_((OBJECT vtext,  V_OB_EVAL_TYPE eval_type,
	 DRAW_ENV *de));
OBJECT VOvtGetSlotTable V_P_((OBJECT vtext));
void VOvtSetSlotTable V_P_((OBJECT vtext, OBJECT slots));
ADDRESS VOvtDspEnv V_P_((OBJECT vtext, ADDRESS *dspenvp));

/***
*** 
***/




/* VO/VOxform.c */
OBJECT VOxfMatCreate V_P_((register float matrix[3][3]));
OBJECT VOxfRotCreate V_P_((double angle, LONG x, LONG y));
OBJECT VOxfStCreate V_P_((double scale_factor,  LONG x_offset,
	 LONG y_offset));
OBJECT VOxfSxytCreate V_P_((double x_scale,  double y_scale,
	 LONG x_offset,  LONG y_offset));
LONG VOxfStatistic V_P_((int Flag));
OBJECT VOxfReference V_P_((OBJECT xform));
void VOxfDereference V_P_((OBJECT xform));
int VOxfRefCount V_P_((OBJECT xform));
BOOLPARAM VOxfValid V_P_((OBJECT xform));
void VOxfSave V_P_((OBJECT xform, OBJECT stream_obj));
OBJECT VOxfRetrieve V_P_((OBJECT stream_obj));
OBJECT VOxfCatCreate V_P_((OBJECT xform, OBJECT xform2));
OBJECT VOxfInvCreate V_P_((OBJECT xform));
int VOxfPoint V_P_((OBJECT xform, register DV_POINT *pt));
void VOxfMatGet V_P_((OBJECT xform,  register float outmat[3][3]));
void VOxfDpPoint V_P_((OBJECT xform,  register double *x,
	 register double *y));
void VOxfDrPoint V_P_((OBJECT xform,  register double *x,
	 register double *y));
double VOxfScale V_P_((OBJECT xform));
void VOxfDump V_P_((OBJECT xform));


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* VOFUNDECL_H */
